#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=prog.ico
#AutoIt3Wrapper_Outfile=Galgenraten.exe
#AutoIt3Wrapper_Res_Description=Galgenraten
#AutoIt3Wrapper_Res_Fileversion=4.0.0.0
#AutoIt3Wrapper_Res_LegalCopyright=Oscar (www.autoit.de)
#AutoIt3Wrapper_Res_Language=1031
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <Array.au3>
#include <ButtonConstants.au3>
#include <Crypt.au3>
#include <Date.au3>
#include <GUIConstantsEx.au3>
#include <GuiListView.au3>
#include <EditConstants.au3>
#include <Misc.au3>
#include <StaticConstants.au3>
#include <String.au3>
#include <WindowsConstants.au3>
#include <WinAPIGdi.au3>
#include '_GuiCtrlSetImageEx.au3'
#include '_resources.au3'

Opt('TrayAutoPause', 0)
Opt('GUIOnEventMode', 1)

Global $sTitle = 'Galgenraten'
Global $sVersion = '4.0.0.0'
Global $sDate = '08.02.2015'
If _Singleton($sTitle, 1) = 0 Then Exit MsgBox(48, StringFormat('%s   v%3.3s', $sTitle, $sVersion), 'Das Programm luft bereits!')
If Not @Compiled And _VersionCompare(@AutoItVersion, '3.3.12.0') = -1 Then Exit MsgBox(16, StringFormat('%s   v%3.3s', $sTitle, $sVersion), 'Ihre AutoIt-Version ist zu alt!' & @CRLF & 'Das Programm wird beendet!')

Global $iX = -1, $iY = -1
Global $aData = _CheckMonitor()
If @error Then Exit MsgBox(48, StringFormat('%s   v%3.3s', $sTitle, $sVersion), 'Fehler beim erkennen der Monitore!')
For $i = 1 To $aData[0][0]
	If $aData[$i][3] >= 1920 And $aData[$i][4] >= 1080 Then
		$iX = $aData[$i][1]
		$iY = $aData[$i][2]
		ExitLoop
	EndIf
Next
If $iX = -1 Then Exit MsgBox(48, StringFormat('%s   v%3.3s', $sTitle, $sVersion), 'Es existiert kein Monitor mit min. FullHD-Auflsung (1920 x 1080px)!')
_Crypt_Startup()
SRandom(@MSEC)
Global $sAppDir = @AppDataDir & '\Galgenraten4\'
If Not FileExists($sAppDir) Then
	If Not DirCreate($sAppDir) Then
		$sAppDir = @ScriptDir & '\Galgenraten4\'
		If Not FileExists($sAppDir) Then
			If Not DirCreate($sAppDir) Then
				Exit MsgBox(48, StringFormat('%s   v%3.3s', $sTitle, $sVersion), 'Das Anwendungsverzeichnis konnte nicht erstellt werden!' & @CRLF & 'Schreibrechte fehlen oder der Datentrger ist schreibgeschtzt.')
			EndIf
		EndIf
	EndIf
EndIf
Global $sHiScoreFile = $sAppDir & 'Galgenraten4.hsc'
Global $sSaveGame = $sAppDir & 'Galgenraten4.sav'
Global $sPassword = 'Hd2Efhmz796bw612Zs72H9FIt86HQ45vLF'
Global $aHiScore[999], $aSaveGame[1] = ['']
Global $fSaveDisable = True, $fLoadDisable = False, $fSave = False
_LoadHiScore($aHiScore, $sHiScoreFile, $sPassword)
;~ _ArrayDisplay($aHiScore)

Global $sIniFile = $sAppDir & 'Galgenraten4.ini'
Global $fSound = IniRead($sIniFile, 'Config', 'Sound', True) = 'True'
Global $sMaxWord = _ArrayFindMaxLen($aWords) ; <- Rckgabe: das lngste Wort
Global $iMaxWordLen = @extended ; <- @extended = die Wortlnge
Global $aTempWords = $aWords, $iMaxIndex = UBound($aTempWords) - 1
Global $iScreenWidth = 1920, $iScreenHeight = 1080, $iSWLeft = 60, $iSWTop = 900, $fInput = False, $fBlink = False, $fNewStart = False

Global $hMainGui = GUICreate($sTitle, $iScreenWidth, $iScreenHeight, $iX, $iY, BitOR($WS_POPUP, $WS_MAXIMIZE))
GUISetOnEvent($GUI_EVENT_CLOSE, '_MainGuiClose')
GUISetOnEvent($GUI_EVENT_RESTORE, '_Restore')
GUISetIcon(@AutoItExe, -1, $hMainGui)
GUISetBKColor(0x000000, $hMainGui)

GUICtrlCreatePic('', $iScreenWidth / 2 - 430, 20, 680, 160)
_GuiCtrlSetImageEx(-1, $hTitlePNG)
GUICtrlCreatePic('', $iScreenWidth / 2 + 260, 44, 48, 48)
GUICtrlSetCursor(-1, 0)
GUICtrlSetTip(-1, 'Programm-Informationen aufrufen')
_GuiCtrlSetImageEx(-1, $hInfoIcon)
GUICtrlSetOnEvent(-1, '_ProgInfo')

Global $idEmotion = GUICtrlCreatePic('', 150, 30, 128, 128)
_GuiCtrlSetImageEx(-1, $ahEmo[1])

Global $idHiScore = GUICtrlCreatePic('', $iScreenWidth - 540, 42, 128, 128)
GUICtrlSetCursor(-1, 0)
_GuiCtrlSetImageEx(-1, $hHiScore)
GUICtrlSetOnEvent(-1, '_OpenHiScore')
GUICtrlSetTip(-1, 'Die Bestenliste aufrufen')

Global $idSoundIcon = GUICtrlCreatePic('', $iScreenWidth - 350, 52, 128, 128)
GUICtrlSetCursor(-1, 0)
_GuiCtrlSetImageEx(-1, $ahSoundIcon[$fSound])
GUICtrlSetOnEvent(-1, '_SwitchSound')
GUICtrlSetTip(-1, 'Sound ein-/ausschalten')

Global $idRealTime = GUICtrlCreateLabel('', $iScreenWidth - 230, 12, 220, 30, $SS_CENTER)
GUICtrlSetFont(-1, 22, 400, 0, 'erbos draco 1st open nbp', 4)
GUICtrlSetColor(-1, 0x99BBFF)
GUICtrlSetTip(-1, 'Uhrzeit')

GUICtrlCreatePic('', $iScreenWidth - 150, 60, 128, 128)
GUICtrlSetCursor(-1, 0)
_GuiCtrlSetImageEx(-1, $hExitIcon)
GUICtrlSetOnEvent(-1, '_MainGuiClose')
GUICtrlSetTip(-1, 'Programm beenden')

Global $iScoreLeft = 60, $iScoreTop = 240
GUICtrlCreateLabel('Punkte:', $iScoreLeft + 20, $iScoreTop - 40, 320, 40)
GUICtrlSetFont(-1, 24, 600, 2, 'Times New Roman', 5)
GUICtrlSetColor(-1, 0xFF8800)
Global $idScore = GUICtrlCreateLabel('0', 60, $iScoreTop, 320, 80, $SS_RIGHT, $WS_EX_STATICEDGE)
GUICtrlSetBkColor(-1, 0x000000)
GUICtrlSetColor(-1, 0x44FF77)
GUICtrlSetFont(-1, 52, 400, 0, 'erbos draco 1st open nbp')

GUICtrlCreateLabel('Platz:', 430, $iScoreTop - 40, 320, 40)
GUICtrlSetFont(-1, 24, 600, 2, 'Times New Roman', 5)
GUICtrlSetColor(-1, 0xFF8800)
Global $idPosition = GUICtrlCreateLabel('---', 410, $iScoreTop, 320, 80, $SS_CENTER, $WS_EX_STATICEDGE)
GUICtrlSetBkColor(-1, 0x000000)
GUICtrlSetColor(-1, 0x44FF77)
GUICtrlSetFont(-1, 52, 400, 0, 'erbos draco 1st open nbp')

GUICtrlCreateLabel('Wrter:', 780, $iScoreTop - 40, 320, 40)
GUICtrlSetFont(-1, 24, 600, 2, 'Times New Roman', 5)
GUICtrlSetColor(-1, 0xFF8800)
Global $idWordCount = GUICtrlCreateLabel('0', 760, $iScoreTop, 270, 80, $SS_RIGHT, $WS_EX_STATICEDGE)
GUICtrlSetBkColor(-1, 0x000000)
GUICtrlSetColor(-1, 0x44FF77)
GUICtrlSetFont(-1, 52, 400, 0, 'erbos draco 1st open nbp')

Global $idUserHelp = GUICtrlCreatePic('', 1060, $iScoreTop - 48, 128, 128)
_GuiCtrlSetImageEx(-1, $ahUser[0])
GUICtrlSetCursor(-1, 0)
GUICtrlSetTip(-1, 'Auswahlmen aufrufen')
GUICtrlSetOnEvent(-1, '_UserMenu')

GUICtrlCreateLabel('Name:', 1200, $iScoreTop - 40, 100, 40)
GUICtrlSetFont(-1, 24, 600, 2, 'Times New Roman', 5)
GUICtrlSetColor(-1, 0xFF8800)
Global $idName = GUICtrlCreateLabel('', 1190, $iScoreTop, 710, 80, $SS_CENTER, $WS_EX_STATICEDGE)
GUICtrlSetBkColor(-1, 0x000000)
GUICtrlSetColor(-1, 0x44FF77)
GUICtrlSetFont(-1, 48, 600, 0, 'Times New Roman')

Global $iInputTop = 410
GUICtrlCreateLabel('Galgenbau:', $iSWLeft + 4, $iInputTop - 45, 320, 40)
GUICtrlSetFont(-1, 24, 600, 2, 'Times New Roman', 5)
GUICtrlSetColor(-1, 0xFF8800)
Global $idPic = GUICtrlCreatePic('', $iSWLeft, $iInputTop - 5, 320, 320)
_GuiCtrlSetImageEx(-1, $ahGalgen[0])
Global $idWordScore = GUICtrlCreateLabel('9', $iSWLeft + 265, $iInputTop + 260, 46, 46, $SS_RIGHT)
GUICtrlSetBkColor(-1, 0x000000)
GUICtrlSetColor(-1, 0x44FF77)
GUICtrlSetFont(-1, 32, 400, 0, 'erbos draco 1st open nbp')

GUICtrlCreateLabel('Geratener Buchstabe:', 420, $iInputTop - 45, 320, 40)
GUICtrlSetFont(-1, 24, 600, 2, 'Times New Roman', 5)
GUICtrlSetColor(-1, 0xFF8800)
GUICtrlCreateLabel('', 410, $iInputTop - 5, 320, 320, BitOR($SS_CENTER, $SS_WHITEFRAME))
Global $idDisplayChar = GUICtrlCreateLabel('', 415, $iInputTop, 310, 310, $SS_CENTER)
GUICtrlSetFont(-1, 200, 400, 0, 'Times New Roman', 5)
GUICtrlSetColor(-1, 0x5555FF)
GUICtrlSetBkColor(-1, 0x000000)

Global $idKeyboardLabel = GUICtrlCreateLabel('Noch nicht geratene Buchstaben:', 780, $iInputTop - 45, 1040, 40)
GUICtrlSetFont(-1, 24, 600, 2, 'Times New Roman', 5)
GUICtrlSetColor(-1, 0xFF8800)
GUICtrlCreateLabel('', 760, $iInputTop - 5, 1140, 320, BitOR($SS_CENTER, $SS_WHITEFRAME))
GUICtrlSetState(-1, $GUI_DISABLE)
Global $aKeys = StringSplit('QWERTZUIOPASDFGHJKLYXCVBNM', '', 2)
Global $aidKeys[UBound($aKeys)]
For $i = 0 To 9
	$aidKeys[$i] = GUICtrlCreateButton($aKeys[$i], 784 + $i * 100, $iInputTop + 10, 94, 94)
	GUICtrlSetCursor(-1, 0)
	GUICtrlSetFont(-1, 52, 600, 0, 'Tahoma', 4)
	GUICtrlSetOnEvent(-1, '_PressKey')
Next
For $i = 0 To 8
	$aidKeys[$i + 10] = GUICtrlCreateButton($aKeys[$i + 10], 814 + $i * 100, $iInputTop + 110, 94, 94)
	GUICtrlSetCursor(-1, 0)
	GUICtrlSetFont(-1, 52, 600, 0, 'Tahoma', 4)
	GUICtrlSetOnEvent(-1, '_PressKey')
Next
For $i = 0 To 6
	$aidKeys[$i + 19] = GUICtrlCreateButton($aKeys[$i + 19], 884 + $i * 100, $iInputTop + 210, 94, 94)
	GUICtrlSetCursor(-1, 0)
	GUICtrlSetFont(-1, 52, 600, 0, 'Tahoma', 4)
	GUICtrlSetOnEvent(-1, '_PressKey')
Next
Global $idMinus = GUICtrlCreateButton('-', 784, $iInputTop + 210, 94, 94)
GUICtrlSetCursor(-1, 0)
GUICtrlSetFont(-1, 64, 600, 0, 'Tahoma', 4)
GUICtrlSetOnEvent(-1, '_PressKey')

Global $idSpace = GUICtrlCreateButton('Leertaste', 1584, $iInputTop + 210, 194, 94, $BS_ICON)
GUICtrlSetCursor(-1, 0)
GUICtrlSetFont(-1, 28, 800, 0, 'Tahoma', 4)
GUICtrlSetOnEvent(-1, '_PressKey')

Global $idDel = GUICtrlCreateButton('', 1784, $iInputTop + 10, 94, 94, $BS_ICON)
GUICtrlSetCursor(-1, 0)
GUICtrlSetFont(-1, 52, 600, 0, 'Tahoma', 5)
GUICtrlSetOnEvent(-1, '_PressKey')
Global $hDel = GUICtrlGetHandle($idDel)
_SendMessage($hDel, $BM_SETIMAGE, 0, $ahDel[0])

Global $idEnter = GUICtrlCreateButton('', 1714, $iInputTop + 110, 164, 94, $BS_ICON)
GUICtrlSetCursor(-1, 0)
GUICtrlSetFont(-1, 52, 600, 0, 'Tahoma', 5)
GUICtrlSetOnEvent(-1, '_PressKey')
GUICtrlSetTip(-1, 'Nchstes Wort')
Global $hEnter = GUICtrlGetHandle($idEnter)
_SendMessage($hEnter, $BM_SETIMAGE, 0, $ahOk[0])

Global $idSleep = GUICtrlCreateButton('', 1784, $iInputTop + 210, 94, 94, $BS_ICON)
GUICtrlSetCursor(-1, 0)
GUICtrlSetFont(-1, 52, 600, 0, 'Tahoma', 5)
GUICtrlSetOnEvent(-1, '_Sleep')
GUICtrlSetTip(-1, 'Programm verstecken (als Taschenrechner)', 'Achtung! Der Chef kommt.')
Global $hSleep = GUICtrlGetHandle($idSleep)
_SendMessage($hSleep, $BM_SETIMAGE, 0, $hSleepIcon)

Global $idSearch = GUICtrlCreateLabel('Das gesuchte Wort:', $iSWLeft, $iSWTop - 120, $iScreenWidth - $iSWLeft, 80)
GUICtrlSetFont(-1, 48, 400, 2, 'Times New Roman', 4)
GUICtrlSetColor(-1, 0xFF8800)

Global $aKeyState[UBound($aKeys)], $aTempState[UBound($aKeys)], $iEnterState = GUICtrlGetState($idEnter)
For $i = 0 To UBound($aTempState) - 1
	$aTempState[$i] = BitOR($GUI_SHOW, $GUI_ENABLE)
Next
_RealTime()
_LoadGame()

GUISetState(@SW_SHOW, $hMainGui)
AdlibRegister('_RealTime', 500)
Global $aidSearchWord[1] = [0], $sRandomWord, $iRandomLength, $sGuessChars = '', $iErrorCount = 0, $fInputOk = False, $hToolTip = -1
_GetKeyboardState($aKeyState)
_SetKeyboardState($aTempState)
_SwitchKeyboard()
_WaitForValue($fInputOk, True)
_NextWord()

HotKeySet('{ESC}', '_MainGuiClose')
WinWaitClose($hMainGui)
Exit

Func _WaitForValue(ByRef $Var, $Val)
	Do
		Sleep(10)
	Until $Var = $Val
EndFunc

Func _MainGuiClose()
	If Not _CheckProgEnd() Then Return
	AdlibUnRegister('_RealTime')
	IniWrite($sIniFile, 'Config', 'Sound', $fSound)
	_SaveHiScore($aHiScore, $sHiScoreFile, $sPassword)
	_Crypt_Shutdown()
	GUIDelete($hMainGui)
	Exit
EndFunc

Func _RealTime()
	GUICtrlSetData($idRealTime, StringFormat('%02i:%02i:%02i', @HOUR, @MIN, @SEC))
EndFunc

Func _Sleep() ; Boss-Modus (verstecken als Taschenrechner)
	GUISetIcon('calc.exe', -1, $hMainGui)
	WinSetTitle($hMainGui, '', 'Rechner')
	GUISetState(@SW_MINIMIZE, $hMainGui)
EndFunc

Func _Restore() ; zurck vom Boss-Modus
	GUISetIcon(@AutoItExe, -1, $hMainGui)
	WinSetTitle($hMainGui, '', $sTitle)
EndFunc

Func _UserMenu()
;~ 	If $fInput Then Return
	Local $ret = _ShowUserMenu($iX + 1030, $iY + 324, $hMainGui)
	If $ret = -1 Then Return
	Switch $ret
		Case 0 ; Spiel aufgeben
			_GuiCtrlSetImageEx($idUserHelp, $ahUser[0])
			_ChangePlayer()
			$fLoadDisable = False
		Case 1 ; Spiel speichern
			_SaveGame()
			_SaveGameGui($iX + 1030, $iY + 324, $hMainGui)
			$fSaveDisable = True
			$fLoadDisable = False
			$fSave = True
			_ChangePlayer()
			$fSave = False
		Case 2 ; Spiel laden
			_LoadGame()
			If @error Then Return
			Local $iSelect = _LoadGameGui($iX + 1030, $iY + 324, $hMainGui)
			If $iSelect = -1 Then Return
			Local $sData = StringSplit($aSaveGame[$iSelect], '|', 2)
			GUICtrlSetData($idName, $sData[1])
			GUICtrlSetData($idScore, $sData[2])
			GUICtrlSetData($idWordCount, $sData[3])
			_CheckPosition()
			_ArrayDelete($aSaveGame, $iSelect)
			_FileSaveGame()
		Case 3 ; Namen ndern
			_GuiCtrlSetImageEx($idUserHelp, $ahUser[0])
			_GetKeyboardState($aKeyState)
			_SetKeyboardState($aTempState)
			$iEnterState = GUICtrlGetState($idEnter)
			_SwitchKeyboard()
	EndSwitch
EndFunc

Func _ChangePlayer()
	If Not $fSave Then
		Local $iPosition = _CheckPosition()
		If $iPosition >= 0 And $iPosition < 999 Then
			_InsertHiScore($iPosition)
			$aHiScore[$iPosition] = $iPosition + 1 & '|' & GUICtrlRead($idName) & '|' & GUICtrlRead($idScore) & '|' & GUICtrlRead($idWordCount)
			_GuiCtrlSetImageEx($idEmotion, $ahEmo[0])
		Else
			_GuiCtrlSetImageEx($idEmotion, $ahEmo[2])
		EndIf
		_SolveWord()
	EndIf
	GUICtrlSetData($idScore, 0)
	GUICtrlSetData($idWordCount, 0)
	$iErrorCount = 0
	For $i = 0 To UBound($aidKeys) - 1
		GUICtrlSetState($aidKeys[$i], $GUI_DISABLE)
	Next
	_SendMessage($hEnter, $BM_SETIMAGE, 0, $ahOk[1])
	GUICtrlSetState($idEnter, $GUI_ENABLE)
	If Not $fSave Then _ShowHiScore($iPosition, $ix + 690, $iY + 40, $hMainGui)
	GUICtrlSetData($idPosition, '---')
	GUICtrlSetData($idName, '')
	_GetKeyboardState($aKeyState)
	_SetKeyboardState($aTempState)
	_SwitchKeyboard()
	$fNewStart = True
EndFunc

Func _LoadGame()
	If Not FileExists($sSaveGame) Then Return SetError(1, 0, 0)
	Local $sFile = FileRead($sSaveGame)
	Local $bEncrypted = _Crypt_DecryptData($sFile, $sPassword, $CALG_AES_256)
	If @error Then Return SetError(2, 0, 0)
	Local $sEncrypted = BinaryToString($bEncrypted)
	$aSaveGame = StringSplit($sEncrypted, @CRLF, 3)
	ReDim $aSaveGame[UBound($aSaveGame) - 1]
EndFunc

Func _SaveGame()
	If UBound($aSaveGame) < 1 Then Global $aSaveGame[1] = ['']
	_ArrayInsert($aSaveGame, 0, '')
	$aSaveGame[0] = StringFormat('%s|%s|%s|%s', _NowDate(), GUICtrlRead($idName), GUICtrlRead($idScore), GUICtrlRead($idWordCount))
	If $aSaveGame[1] = '' Then ReDim $aSaveGame[UBound($aSaveGame) - 1]
	_FileSaveGame()
EndFunc

Func _FileSaveGame()
	Local $sFile = ''
	For $sData In $aSaveGame
		$sFile &= $sData & @CRLF
	Next
	Local $bEncrypted = _Crypt_EncryptData($sFile, $sPassword, $CALG_AES_256)
	Local $hFile = FileOpen($sSaveGame, 18)
	If $hFile = -1 Then Return
	FileWrite($hFile, $bEncrypted)
	FileClose($hFile)
EndFunc

Func _LoadGameGui($iLeft = -1, $iTop = -1, $hParent = 0)
	If UBound($aSaveGame) < 1 Then Return SetError(1, 0, -1)
	Opt('GUIOnEventMode', 0)
	Local $iSelect = -1, $iDblClickTimer = TimerInit()
	Local $iDoubleClickSpeed = RegRead('HKCU\Control Panel\Mouse', 'DoubleClickSpeed')
	Local $hSaveGui = GUICreate('', 860, 675, $iLeft, $iTop, BitOR($WS_POPUPWINDOW, $WS_SIZEBOX), $WS_EX_CONTROLPARENT, $hParent)
	GUISetBkColor(0xFFFFCC, $hSaveGui)
	GUICtrlCreatePic('', 10, 8, 128, 128)
	_GuiCtrlSetImageEx(-1, $ahUser[1], False, 0xFFFFFFCC)
	GUICtrlCreateLabel('Welcher Spielstand soll geladen werden?', 140, 10, 630, 124, $SS_CENTER)
	GUICtrlSetFont(-1, 40, 400, 0, 'Times New Roman', 4)
	Local $idClose = GUICtrlCreatePic('', 792, 5, 64, 64)
	GUICtrlSetCursor(-1, 0)
	_GuiCtrlSetImageEx(-1, $hClose, False, 0xFFFFFFCC)
	Local $aColVal[4][2] = [[190, 2], [340, 0], [130, 1], [130, 1]]
	Local $idSaveGameList = GUICtrlCreateListView('Datum|Name|Punkte|Wrter', 10, 146, 840, 444)
	GUICtrlSetFont(-1, 28, 400, 0, 'Times New Roman', 5)
	For $i = 0 To UBound($aColVal) - 1
		_GUICtrlListView_SetColumnWidth($idSaveGameList, $i, $aColVal[$i][0])
		_GUICtrlListView_JustifyColumn($idSaveGameList, $i, $aColVal[$i][1])
	Next
	For $i = 0 To UBound($aSaveGame) - 1
		GUICtrlCreateListViewItem($aSaveGame[$i], $idSaveGameList)
	Next
	Local $idLoad = GUICtrlCreateButton('Spielstand laden', 500, 605, 350, 56)
	GUICtrlSetFont(-1, 24, 400, 0, 'Verdana', 4)
	GUICtrlSetCursor(-1, 0)
	GUICtrlSetState(-1, $GUI_DISABLE)
	GUISetState(@SW_SHOW, $hSaveGui)
	Sleep($iDoubleClickSpeed * 2)
	While True
		Switch GUIGetMsg()
			Case $GUI_EVENT_PRIMARYUP
				If TimerDiff($iDblClickTimer) < $iDoubleClickSpeed Then
					$iSelect = ControlListView($hSaveGui, '', $idSaveGameList, 'GetSelected', 0)
					ExitLoop
				EndIf
				$iDblClickTimer = TimerInit()
			Case $idLoad
				$iSelect = ControlListView($hSaveGui, '', $idSaveGameList, 'GetSelected', 0)
				ExitLoop
			Case $idClose
				ExitLoop
		EndSwitch
		If ControlListView($hSaveGui, '', $idSaveGameList, 'GetSelectedCount') = 1 Then
			If BitAND(GUICtrlGetState($idLoad), $GUI_DISABLE) Then GUICtrlSetState($idLoad, $GUI_ENABLE)
		Else
			If BitAND(GUICtrlGetState($idLoad), $GUI_ENABLE) Then GUICtrlSetState($idLoad, $GUI_DISABLE)
		EndIf
	WEnd
	GUIDelete($hSaveGui)
	Opt('GUIOnEventMode', 1)
	Return $iSelect
EndFunc

Func _SaveGameGui($iLeft = -1, $iTop = -1, $hParent = 0)
	If UBound($aSaveGame) < 1 Then Return SetError(1, 0, 0)
	Opt('GUIOnEventMode', 0)
	Local $hSaveGui = GUICreate('', 860, 670, $iLeft, $iTop, BitOR($WS_POPUPWINDOW, $WS_SIZEBOX), $WS_EX_CONTROLPARENT, $hParent)
	GUISetBkColor(0xFFFFCC, $hSaveGui)
	GUICtrlCreatePic('', 10, 8, 128, 128)
	_GuiCtrlSetImageEx(-1, $ahUser[3], False, 0xFFFFFFCC)
	GUICtrlCreateLabel('Spielstand gespeichert!', 140, 40, 580, 124, $SS_CENTER)
	GUICtrlSetFont(-1, 40, 400, 0, 'Times New Roman', 4)
	Local $idClose = GUICtrlCreatePic('', 792, 5, 64, 64)
	GUICtrlSetCursor(-1, 0)
	_GuiCtrlSetImageEx(-1, $hClose, False, 0xFFFFFFCC)
	Local $aColVal[4][2] = [[190, 2], [340, 0], [130, 1], [130, 1]]
	Local $idSaveGameList = GUICtrlCreateListView('Datum|Name|Punkte|Wrter', 10, 145, 840, 450)
	GUICtrlSetFont(-1, 28, 400, 0, 'Times New Roman', 5)
	For $i = 0 To UBound($aColVal) - 1
		_GUICtrlListView_SetColumnWidth($idSaveGameList, $i, $aColVal[$i][0])
		_GUICtrlListView_JustifyColumn($idSaveGameList, $i, $aColVal[$i][1])
	Next
	For $i = 0 To UBound($aSaveGame) - 1
		GUICtrlCreateListViewItem($aSaveGame[$i], $idSaveGameList)
		If $i = 0 Then GUICtrlSetBkColor(-1, 0x99FF99)
	Next
	Local $idOk = GUICtrlCreateButton('Ok', 360, 605, 140, 56)
	GUICtrlSetFont(-1, 24, 400, 0, 'Verdana', 4)
	GUICtrlSetCursor(-1, 0)
	GUISetState(@SW_SHOW, $hSaveGui)
	While True
		Switch GUIGetMsg()
			Case $idClose, $idOk
				ExitLoop
		EndSwitch
	WEnd
	GUIDelete($hSaveGui)
	Opt('GUIOnEventMode', 1)
EndFunc


Func _GetKeyboardState(ByRef $aState)
	For $i = 0 To UBound($aKeys) - 1
		$aState[$i] = GUICtrlGetState($aidKeys[$i])
	Next
EndFunc

Func _SetKeyboardState(ByRef $aState)
	For $i = 0 To UBound($aKeys) - 1
		GUICtrlSetState($aidKeys[$i], $aState[$i])
	Next
EndFunc

Func _ShowUserMenu($iLeft = -1, $iTop = -1, $hParent = 0)
	Opt('GUIOnEventMode', 0)
	If UBound($aSaveGame) < 1 Then $fLoadDisable = True
	Local $hUserGui = GUICreate('', 664, 664, $iLeft, $iTop, BitOR($WS_POPUPWINDOW, $WS_SIZEBOX), $WS_EX_CONTROLPARENT, $hParent)
	GUISetBkColor(0xEEEEEE, $hUserGui)
	Local $idClose = GUICtrlCreatePic('', 600, 0, 64, 64)
	GUICtrlSetCursor(-1, 0)
	_GuiCtrlSetImageEx(-1, $hClose, False, 0xFFEEEEEE)
	Local $aUserComm[4][2] = [[4, 'Spiel aufgeben'], [3, 'Spiel speichern'], [1, 'Spiel laden'], [0, 'Namen ndern']]
	Local $aidUserComm[4]
	For $i = 0 To UBound($aUserComm) - 1
		GUICtrlCreatePic('', 20, 30 + $i * 160, 128, 128)
		_GuiCtrlSetImageEx(-1, $ahUser[$aUserComm[$i][0]], False, 0xFFEEEEEE)
		$aidUserComm[$i] = GUICtrlCreateButton($aUserComm[$i][1], 180, 72 + $i * 160, 400, 80)
		GUICtrlSetCursor(-1, 0)
		GUICtrlSetFont(-1, 42, 400, 0, 'Times New Roman', 5)
		If $i = 1 And $fSaveDisable Then GUICtrlSetState(-1, $GUI_DISABLE)
		If $i = 2 And $fLoadDisable Then GUICtrlSetState(-1, $GUI_DISABLE)
	Next
	GUISetState(@SW_SHOW, $hUserGui)
	Local $msg, $ret = -1, $iError = 0
	While True
		$msg = GUIGetMsg()
		Switch $msg
			Case $idClose
				$iError = 1
				ExitLoop
			Case $aidUserComm[0], $aidUserComm[1], $aidUserComm[2], $aidUserComm[3]
				$ret = ($msg - $aidUserComm[0]) / 2
				ExitLoop
		EndSwitch
	WEnd
	GUIDelete($hUserGui)
	Opt('GUIOnEventMode', 1)
	Return SetError($iError, 0, $ret)
EndFunc   ;==>_ShowUserMenu

Func _SaveHiScore(ByRef $aHiScore, $sPath, $sPassword)
	Local $sData = '', $sEncrypted, $hFile
	For $sLine In $aHiScore
		$sData &= $sLine & @CRLF
	Next
	$sData = StringTrimRight($sData, 2)
	$sEncrypted = _Crypt_EncryptData($sData, $sPassword, $CALG_AES_256)
	$hFile = FileOpen($sPath, 2 + 16)
	If $hFile <> -1 Then
		FileWrite($hFile, $sEncrypted)
		FileClose($hFile)
	EndIf
EndFunc

Func _LoadHiScore(ByRef $aHiScore, $sPath, $sPassword)
	Local $sFile, $bEncrypted, $sEncrypted, $aLines
	$sFile = FileRead($sPath)
	If @error Then
		_CreateHiScore($aHiScore)
	Else
		$bEncrypted = _Crypt_DecryptData($sFile, $sPassword, $CALG_AES_256)
		If @error Then
			_CreateHiScore($aHiScore)
		Else
			$sEncrypted = BinaryToString($bEncrypted)
			$aLines = StringSplit($sEncrypted, @CRLF, 3)
			If UBound($aLines) <> UBound($aHiScore) Then
				_CreateHiScore($aHiScore)
			Else
				$aHiScore = $aLines
			EndIf
		EndIf
	EndIf
EndFunc

Func _CreateHiScore(ByRef $aHiScore)
	For $i = 0 To UBound($aHiScore) - 1
		$aHiScore[$i] =  $i + 1 & '|Computer|' & Int((UBound($aHiScore) - $i) / 2) + 1 & '|0' ; Platz | Name | Punkte | Wrter
	Next
EndFunc

Func _OpenHiScore()
	_ShowHiScore(-1, $ix + 690, $iY + 40, $hMainGui)
EndFunc

Func _ShowHiScore($iPosition = -1, $iLeft = -1, $iTop = -1, $hParent = 0)
	Opt('GUIOnEventMode', 0)
	Local $hHiScoreGui = GUICreate('', 800, 900, $iLeft, $iTop, BitOR($WS_POPUPWINDOW, $WS_SIZEBOX), $WS_EX_CONTROLPARENT, $hParent)
	GUISetBkColor(0xFFFFCC, $hHiScoreGui)
	GUICtrlCreatePic('', 8, 8, 128, 128)
	_GuiCtrlSetImageEx(-1, $hHiScore, False, 0xFFFFFFCC)
	GUICtrlCreateLabel('Bestenliste', 200, 50, 426, 64, $SS_CENTER)
	GUICtrlSetFont(-1, 52, 400, 0, 'Times New Roman', 5)
	Local $idClose = GUICtrlCreatePic('', 728, 5, 64, 64)
	GUICtrlSetCursor(-1, 0)
	_GuiCtrlSetImageEx(-1, $hClose, False, 0xFFFFFFCC)
	Local $aColVal[4][2] = [[100, 2], [380, 0], [130, 1], [130, 1]]
	Local $idHiScoreList = GUICtrlCreateListView('Platz|Name|Punkte|Wrter', 10, 146, 780, 744)
	GUICtrlSetFont(-1, 28, 400, 0, 'Times New Roman', 5)
	For $i = 0 To UBound($aColVal) - 1
		_GUICtrlListView_SetColumnWidth($idHiScoreList, $i, $aColVal[$i][0])
		_GUICtrlListView_JustifyColumn($idHiScoreList, $i, $aColVal[$i][1])
	Next
	For $i = 0 To UBound($aHiScore) - 1
		GUICtrlCreateListViewItem($aHiScore[$i], $idHiScoreList)
	Next
	GUISetState(@SW_SHOW, $hHiScoreGui)
	If $iPosition > -1 And $iPosition < 999 Then
		_GUICtrlListView_EnsureVisible($idHiScoreList, $iPosition)
		_GUICtrlListView_SetItemSelected($idHiScoreList, $iPosition, True, True)
	EndIf
	Do
	Until GUIGetMsg() = $idClose
	GUIDelete($hHiScoreGui)
	Opt('GUIOnEventMode', 1)
EndFunc

Func _CheckMonitor()
	Local $aPos, $aData = _WinAPI_EnumDisplayMonitors()
	If IsArray($aData) Then
		ReDim $aData[$aData[0][0] + 1][5]
		For $i = 1 To $aData[0][0]
			$aPos = _WinAPI_GetPosFromRect($aData[$i][1])
			For $j = 0 To 3
				$aData[$i][$j + 1] = $aPos[$j]
			Next
		Next
		Return SetError(0, 0, $aData)
	Else
		Return SetError(1, 0, 0)
	EndIf
EndFunc

Func _SwitchSound()
	$fSound = Not $fSound
	If $fSound Then
		_GuiCtrlSetImageEx($idSoundIcon, $ahSoundIcon[1])
	Else
		_GuiCtrlSetImageEx($idSoundIcon, $ahSoundIcon[0])
	EndIf
EndFunc

Func _NextWord()
	_GuiCtrlSetImageEx($idPic, $ahGalgen[0])
	GUICtrlSetData($idWordScore, 9)
	_GuiCtrlSetImageEx($idEmotion, $ahEmo[1])
	If $fSound Then _PlayMP3FromMem($ahSound[2], 500)
	_SendMessage($hEnter, $BM_SETIMAGE, 0, $ahOk[0])
	GUICtrlSetState($idEnter, $GUI_DISABLE)
	$sRandomWord = _CreateSearchWord($aidSearchWord)
	$iRandomLength = StringLen($sRandomWord)
;~ 	ToolTip($sRandomWord, 1625, 360, 'Test:') ; <- nur zum testen
	For $i = 0 To UBound($aidKeys) - 1
		GUICtrlSetState($aidKeys[$i], $GUI_ENABLE)
		GUICtrlSetState($aidKeys[$i], $GUI_SHOW)
	Next
	$sGuessChars = ''
	$iErrorCount = 0
EndFunc

Func _OpenBigToolTip($sTitle, $sIconfile, $sMsg, $iLeft, $iTop, $iWidth = 560, $iHeight = 100, $hParent = -1)
	Local $hToolTip = GUICreate('', $iWidth, $iHeight, $iLeft, $iTop, BitOR($WS_POPUPWINDOW, $WS_SIZEBOX), $WS_EX_CONTROLPARENT, $hParent)
	GUISetBkColor(0xFFFFCC, $hToolTip)
	GUICtrlCreatePic('', 5, 5, 48, 48)
	_GuiCtrlSetImageEx(-1, $sIconfile, False, 0xFFFFFFCC)
	GUICtrlCreateLabel($sTitle, 70, 10, $iWidth - 140, 40, $SS_LEFT)
	GUICtrlSetFont(-1, 24, 600, 2, 'Tahoma', 4)
	GUICtrlCreateLabel($sMsg, 10, 60, $iWidth - 20, $iHeight - 70, $SS_LEFT)
	GUICtrlSetFont(-1, 18, 600, 2, 'Tahoma', 4)
	GUISetState(@SW_SHOW, $hToolTip)
	Return $hToolTip
EndFunc

Func _CloseBigToolTip($hGui)
	GUIDelete($hGui)
EndFunc

Func _SwitchKeyboard()
	Local $sIconfile = $hClick
	$fInput = Not $fInput
	If $fInput Then
		$hToolTip = _OpenBigToolTip('Bitte Namen eingeben:', $sIconfile, 'Mit Hilfe der Maus und der Eingabe-Tastatur.', $iX + 1300, $iY + 120, 560, 100, $hMainGui)
		GUICtrlSetData($idKeyboardLabel, 'Eingabe-Tastatur:')
		_SendMessage($hDel, $BM_SETIMAGE, 0, $ahDel[1])
		GUICtrlSetState($idDel, $GUI_ENABLE)
		_SendMessage($hEnter, $BM_SETIMAGE, 0, $ahOk[1])
		GUICtrlSetState($idMinus, $GUI_ENABLE)
		GUICtrlSetState($idEnter, $GUI_ENABLE)
		GUICtrlSetTip($idEnter, 'Eingabe beenden')
		GUICtrlSetState($idSpace, $GUI_ENABLE)
		AdlibRegister('_CursorBlink', 500)
	Else
		AdlibUnRegister('_CursorBlink')
		_CloseBigToolTip($hToolTip)
		GUICtrlSetData($idKeyboardLabel, 'Noch nicht geratene Buchstaben:')
		_SendMessage($hDel, $BM_SETIMAGE, 0, $ahDel[0])
		GUICtrlSetState($idDel, $GUI_DISABLE)
		GUICtrlSetState($idMinus, $GUI_DISABLE)
		If BitAND($iEnterState, $GUI_DISABLE) Then
			_SendMessage($hEnter, $BM_SETIMAGE, 0, $ahOk[0])
			GUICtrlSetState($idEnter, $GUI_DISABLE)
		EndIf
		GUICtrlSetTip($idEnter, 'Nchstes Wort')
		GUICtrlSetState($idSpace, $GUI_DISABLE)
		If $fBlink Then _CursorBlink()
	EndIf
EndFunc

Func _CursorBlink()
	$fBlink = Not $fBlink
	Local $sName = ($fBlink = True) ? GUICtrlRead($idName) & '|' : StringReplace(GUICtrlRead($idName), '|', '')
	GUICtrlSetData($idName, $sName)
EndFunc

Func _PressKey()
	If $fInput Then
		Local $sChar = ''
		Local $sName = StringReplace(GUICtrlRead($idName), '|', '')
		Switch @GUI_CtrlId
			Case $idDel
				GUICtrlSetData($idName, _StringProper(StringTrimRight($sName, 1)))
				Return
			Case $idEnter
				If $sName = '' Then
					If $fSound Then _PlayMP3FromMem($ahSound[3], 800)
					Return
				EndIf
				_GuiCtrlSetImageEx($idUserHelp, $ahUser[2])
				_SwitchKeyboard()
				_SetKeyboardState($aKeyState)
				$sName = StringReplace(GUICtrlRead($idName), '|', '')
				GUICtrlSetData($idName, $sName)
				GUICtrlSetState($idEnter, $iEnterState)
				$fInputOk = True
				If $fNewStart Then
					$fNewStart = False
					_NextWord()
				EndIf
				Return
			Case $idSpace
				$sChar = ' '
			Case Else
				$sChar = GUICtrlRead(@GUI_CtrlId)
		EndSwitch
		If StringLen($sName) < 21 Then GUICtrlSetData($idName, _StringProper($sName & $sChar))
		Return
	EndIf
	If @GUI_CtrlId = $idEnter Then
		$fSaveDisable = True
		_NextWord()
		Return
	EndIf
	Local $sInput = StringLower(GUICtrlRead(@GUI_CtrlId)), $iWordScore, $iPosition = 1000
	If StringInStr($sGuessChars, $sInput) Then Return
	GUICtrlSetState(@GUI_CtrlId, $GUI_HIDE)
	If Asc($sInput) > 96 And Asc($sInput) < 123 Then
		GUICtrlSetData($idDisplayChar, StringUpper($sInput))
		If Not _CharCheck($sInput) Then
			_GuiCtrlSetImageEx($idEmotion, $ahEmo[2])
			If $fSound And $iErrorCount < 8 Then _PlayMP3FromMem($ahSound[3], 500)
			$iErrorCount += 1
			_GuiCtrlSetImageEx($idPic, $ahGalgen[$iErrorCount])
			GUICtrlSetData($idWordScore, 9 - $iErrorCount)
			If $iErrorCount = 9 Then ; Spieler hat das Wort nicht erraten
				$iPosition = _CheckPosition()
				If $iPosition >= 0 And $iPosition < 999 Then
					_InsertHiScore($iPosition)
					$aHiScore[$iPosition] = $iPosition + 1 & '|' & GUICtrlRead($idName) & '|' & GUICtrlRead($idScore) & '|' & GUICtrlRead($idWordCount)
				EndIf
				_GuiCtrlSetImageEx($idEmotion, $ahEmo[4])
				_SolveWord()
				GUICtrlSetData($idScore, 0)
				$iErrorCount = 0
				For $i = 0 To UBound($aidKeys) - 1
					GUICtrlSetState($aidKeys[$i], $GUI_DISABLE)
				Next
				If $fSound Then _PlayMP3FromMem($ahSound[4], 2500)
				_SendMessage($hEnter, $BM_SETIMAGE, 0, $ahOk[1])
				GUICtrlSetState($idEnter, $GUI_ENABLE)
				_ShowHiScore($iPosition, $ix + 690, $iY + 40, $hMainGui)
				GUICtrlSetData($idPosition, '---')
				GUICtrlSetData($idDisplayChar, '')
				GUICtrlSetData($idWordCount, 0)
			EndIf
		Else
			_GuiCtrlSetImageEx($idEmotion, $ahEmo[3])
		EndIf
		$sGuessChars &= $sInput
		If $iRandomLength = 0 Then ; Spieler hat das Wort erraten
			_GuiCtrlSetImageEx($idEmotion, $ahEmo[0])
			GUICtrlSetData($idDisplayChar, '')
			For $i = 0 To UBound($aidKeys) - 1
				GUICtrlSetState($aidKeys[$i], $GUI_DISABLE)
			Next
			GUICtrlSetData($idWordCount, GUICtrlRead($idWordCount) + 1)
			$iWordScore = GUICtrlRead($idWordScore)
			For $i = $iWordScore - 1 To 0 Step - 1
				GUICtrlSetData($idScore, GUICtrlRead($idScore) + 1)
				_CheckPosition()
				If $fSound Then _PlayMP3FromMem($ahSound[0], 200)
				GUICtrlSetData($idWordScore, $i)
			Next
			_SendMessage($hEnter, $BM_SETIMAGE, 0, $ahOk[1])
			GUICtrlSetState($idEnter, $GUI_ENABLE)
			If GUICtrlRead($idWordCount) = 9999 Then ; Mehr als 9999 Wrter knnen nicht angezeigt werden -> Spieler = Superspieler
				Local $sMsg = '\nHerzlichen Glckwunsch!\nSie haben die maximale Anzahl an Wrtern erraten!\nMit einem Punktestand von %i Punkten werden Sie in die Liste der Galgenraten-Superspieler aufgenommen.'
				Local $hHSGui = _OpenBigToolTip('Galgenraten - Superspieler', $hHiScore, StringFormat($sMsg, GUICtrlRead($idScore)), $iX + 600, $iY + 420, 640, 280, $hMainGui)
				If $fSound Then _PlayMP3FromMem($hHiScoreSound, 5000)
				Local $idClose = GUICtrlCreatePic('', 572, 0, 64, 64)
				GUICtrlSetCursor(-1, 0)
				_GuiCtrlSetImageEx(-1, $hClose, False, 0xFFFFFFCC)
				Opt('GUIOnEventMode', 0)
				Do
				Until GUIGetMsg() = $idClose
				GUIDelete($hHSGui)
				Opt('GUIOnEventMode', 1)
				_ChangePlayer()
			Else
				$fSaveDisable = False
			EndIf
		EndIf
	EndIf
EndFunc

Func _InsertHiScore($iPosition) ; verschiebt die Pltze unterhalb von $iPosition um einen Platz nach unten, um Platz fr den neuen Eintrag zu schaffen
	If $iPosition > 998 Or $iPosition < 0 Then Return
	For $i = UBound($aHiScore) - 1 To $iPosition + 1 Step -1
		$aHiScore[$i] = $i + 1 & StringRegExpReplace($aHiScore[$i - 1], '.+(\|.+\|.+\|.+)', '$1')
	Next
EndFunc

Func _CheckPosition()
	Local $iScore = GUICtrlRead($idScore)
	For $i = 0 To UBound($aHiScore) - 1
		If Number($iScore) > Number(StringRegExpReplace($aHiScore[$i], '.+\|.+\|(.+)\|.+', '$1')) Then
			GUICtrlSetData($idPosition, $i + 1)
			Return $i
		EndIf
	Next
	GUICtrlSetData($idPosition, '---')
	Return -1
EndFunc

Func _CharCheck($sChar)
	Local $fRet = False
	For $i = 1 To StringLen($sRandomWord)
		If StringMid($sRandomWord, $i, 1) = $sChar Then
			If Not $fRet Then _GuiCtrlSetImageEx($idEmotion, $ahEmo[3])
			If $fSound Then _PlayMP3FromMem($ahSound[0], 220)
			If $i > 1 Then
				GUICtrlSetData($aidSearchWord[$i - 1], $sChar)
			Else
				GUICtrlSetData($aidSearchWord[$i - 1], StringUpper($sChar))
			EndIf
			$iRandomLength -= 1
			$fRet = True
		EndIf
	Next
	Return $fRet
EndFunc

Func _SolveWord()
	For $i = 1 To StringLen($sRandomWord)
		If GUICtrlRead($aidSearchWord[$i - 1]) = '_' Then
			GUICtrlSetData($aidSearchWord[$i - 1], StringMid($sRandomWord, $i, 1))
			GUICtrlSetColor($aidSearchWord[$i - 1], 0xFF5555)
		EndIf
	Next
EndFunc

Func _CreateSearchWord(ByRef $aidSearchWord)
	If $aidSearchWord[0] <> 0 Then
		For $i = 0 To UBound($aidSearchWord) - 1
			GUICtrlDelete($aidSearchWord[$i])
		Next
	EndIf
	If $iMaxIndex = 0 Then
		$aTempWords = $aWords
		$iMaxIndex = UBound($aTempWords) - 1
	EndIf
	Local $iRandom = Random(0, $iMaxIndex, 1)
	Local $sRandomWord = $aTempWords[$iRandom]
	$aTempWords[$iRandom] = $aTempWords[$iMaxIndex]
	$iMaxIndex -= 1
	Local $iLenght = StringLen($sRandomWord)
	GUICtrlSetData($idSearch, 'Das gesuchte Wort hat ' & $iLenght & ' Buchstaben:')
	ReDim $aidSearchWord[$iLenght]
	For $i = 0 To $iLenght - 1
		$aidSearchWord[$i] = GUICtrlCreateLabel('_', $iSWLeft + $i * 58, $iSWTop, 58, 100, $SS_CENTER)
		GUICtrlSetFont(-1, 64, 600, 0, 'Courier New', 5)
		GUICtrlSetColor(-1, 0x8888FF)
	Next
	Return $sRandomWord
EndFunc

Func _ArrayFindMaxLen(ByRef $aWords)
	Local $iMaxLen = 0, $sWord = '', $iTemp = 0
	For $i = 0 To UBound($aWords) - 1
		$iTemp = StringLen($aWords[$i])
		If $iTemp > $iMaxLen Then
			$iMaxLen = $iTemp
			$sWord = $aWords[$i]
		EndIf
	Next
	Return SetError(0, $iMaxLen, $sWord)
EndFunc

Func _CheckProgEnd()
	Opt('GUIOnEventMode', 0)
	Local $hProgInfo = _OpenBigToolTip($sTitle, $hExitIcon, 'Programm wirklich beenden?', $iX + 1514, $iY + 44, 370, 180, $hMainGui)
	Local $idYes = GUICtrlCreateButton('Ja', 90, 130, 130, 40)
	GUICtrlSetFont(-1, 20, 600, 0, 'Arial', 4)
	GUICtrlSetState(-1, $GUI_ONTOP)
	Local $idNo = GUICtrlCreateButton('Nein', 230, 130, 130, 40)
	GUICtrlSetFont(-1, 20, 600, 0, 'Arial', 4)
	GUICtrlSetState(-1, $GUI_ONTOP)
	Local $fCheck = False
	While True
		Switch GUIGetMsg()
			Case $idYes
				$fCheck = True
				ExitLoop
			Case $idNo
				$fCheck = False
				ExitLoop
		EndSwitch
	WEnd
	GUIDelete($hProgInfo)
	Opt('GUIOnEventMode', 1)
	Return $fCheck
EndFunc

Func _ProgInfo()
	Local $sMsg = 'Version:\t\t%s\nDatum:\t\t%s\nAutor:\t\tOscar (www.autoit.de)\nEMail:\t\tOscar@elektronik-kurs.de\n\nWortliste:\t%i Wrter (lngstes Wort: %i Buchstaben)\n\n'
	$sMsg &= 'Rechtliches:\n'
	$sMsg &= '- Dieses Programm darf, zeitlich unbegrenzt, kostenlos genutzt werden!\n'
	$sMsg &= '- Eine evtl. Weitergabe muss kostenlos, vollstndig und unverndert erfolgen!\n'
	$sMsg &= '- nderungen am Programm drfen nur durch den Autor vorgenommen werden!\n\n'
	$sMsg &= 'Bedanken mchte ich mich an dieser Stelle bei:\n'
	$sMsg &= '- UEZ (www.autoit.de)\n'
	$sMsg &= '\tfr diverse Funktionen zum einbinden der Dateien in das Programm\n'
	$sMsg &= '- Nate Halley\n'
	$sMsg &= '\tfr den Font "Erbos Draco Open NBP Regular"\n'
	$sMsg &= '- Open Icon Library\n'
	$sMsg &= '\tfr die diversen Icons\n'
	Opt('GUIOnEventMode', 0)
	Local $hProgInfo = _OpenBigToolTip($sTitle, $hInfoIcon, StringFormat($sMsg, $sVersion, $sDate, UBound($aWords), $iMaxWordLen), $iX + 400, $iY + 40, 992, 630, $hMainGui)
	Local $idClose = GUICtrlCreatePic('', 926, 0, 64, 64)
	GUICtrlSetCursor(-1, 0)
	_GuiCtrlSetImageEx(-1, $hClose, False, 0xFFFFFFCC)
	Do
	Until GUIGetMsg() = $idClose
	GUIDelete($hProgInfo)
	Opt('GUIOnEventMode', 1)
EndFunc
